﻿if KarmaStub:isLib("LibKarmaAce", 1.1, "$Revision: 44 $") then return end

--[[
	Simple integrated automated lightweight support for other basic desparate libraries and systems
	
	Notes on the locale integration:
	
		Yes, the locale system does load all the reverse lookup tables for all available locale libraries.
		The reason is that all strings for the current locale and for english are already taking memory
		for all the	locale libraries (and for the current locale even if the locale libs didnt exist),
		and its by far more effiecnt to just keep the reverse lookup tables which only hold string
		references anyway. Some applications are hitting the reverse lookup constantly and necessarily,
		up to 100s of times a frame, and allows a very fast non-memory churn way of doign this.	Also this
		allows features which are faster here, closer to the metal, than emulating and separatly tracking
		them per app or use.
				
		Only the final locale system collection is per instance, the rest of the tables and management
		is global. Some forms up lookups are regretibly wrapped and stuck on the Lua side, but watching
		the meters its really about as tight as you could expect and still very fast.	
]]

LibKarmaAce = LibKarmaAce or  {

}


function LibKarmaAce:LoadLocales( frame, inst, locale, L )

	L["Help"] = true
	L["Show Help"] = true
	L["Main Window"] = true
	L["Show Main Window"] = true
	L["Options"] = true
	L["Show Options"] = true
	L["Item Options"] = true
	L["Show Item Options"] = true
	L.ADDON_TOOLTIP = "|cffeda55fClick|r to open main window, |cffeda55fShift-click|r to open options."

	-- already localized
	L["Join"] = JOIN
	L["Leave"] = CHAT_LEAVE

	if locale == "esMX" then
--		L["Help"] = "Spanish"
	end

	-- inst:DebugTable("LibKarmaAce:LoadLocales", locale, L:GetLocale(Name,true))
end

do
	LoadAddOn("Ace3")
	LoadAddOn("Dewdrop-2.0")
	LoadAddOn("LibRock-1.0")
	LoadAddOn("LibBabble-Zone-3.0")
	LoadAddOn("LibBabble-Boss-3.0")
	LoadAddOn("LibBabble-Class-3.0")
	LoadAddOn("LibBabble-Inventory-3.0")
	LoadAddOn("LibBabble-CreatureType-3.0")
	LoadAddOn("LibFuBarPlugin-3.0")
	LoadAddOn("LibDataBroker-1.1")
end

function LibKarmaAce:OnAddonLoaded( frame, inst )
	
	self._acelib = self._acelib or {
		aaoembed = { },
		locale = {
			mt = {	__newindex = function( t, k, v ) if t[1] then t[1][k] = v end; end,
					__index = function( t, k ) if not k then return end
						local _,_,c,s,r,f = string.find(k, "^(|c%x%x%x%x%x%x%x%x)(.-)(|r)$")
						if c then k,s = s,k end
						for i, v in pairs(t) do
							v = (v and type(i) == "number") and v[k]; f = f or v
							if v and (i==1 or v~=k) then
								return c and (c..v..r) or v
							end
						end
						if not f and t[1] then t[1][k] = k end;			-- store capture
						return c and s or (f or k);						-- return cross checked value or defaults
					end, },
			proxy	= {	__newindex = function( t, k, v ) rawset(t[1],k,v==true and k or v) end,	__index = function( t, k ) return rawget(t[1],k); end, },
			proxyr	= { __newindex = function( t, k, v ) end, __index = function( t, k ) for i, v in pairs(t[1]) do if v==k then return i end end end, },
			format  = function( t, s, ... ) return s and string.format(t[s], ...) end,
		},
		defaults = {
			profile = { minimap = { show = 1, position = 225, }, },
			global = { LCapture = { [inst._meta.locale]={} }, LCaptureR = { [inst._meta.locale]={} }, },
		}
	}

	inst._acelib = {
		name	= inst._instance.name.."Ace",
		nameDB	= inst._instance.name.."AceDB",
		nameLDB = inst._instance.name.."AceLDB",
	}
	setmetatable( inst._acelib, { __index = self._acelib } )
	local _inst,_L = inst._acelib, inst._acelib.locale

end

function LibKarmaAce:OnPlayerLogin( frame, inst )

	-- --------- relies on old variables_loaded ----------

	-- global table
	local LibStub = LibStub
	self._acelib.lib = self._acelib.lib or {
		L	= LibStub and LibStub("AceLocale-3.0", true),
		LZ	= LibStub and LibStub("LibBabble-Zone-3.0", true),
		LB	= LibStub and LibStub("LibBabble-Boss-3.0", true),
		LC	= LibStub and LibStub("LibBabble-Class-3.0", true),
		LI	= LibStub and LibStub("LibBabble-Inventory-3.0", true),
		LT	= LibStub and LibStub("LibBabble-CreatureType-3.0", true),
		fu	= LibStub and LibStub("LibFuBarPlugin-3.0", true),
		aao	= LibStub and LibStub("AceAddon-3.0", true),
		ac	= LibStub and LibStub("AceConsole-3.0", true),
		db	= LibStub and LibStub("AceDB-3.0", true),
		ldb	= LibStub and LibStub("LibDataBroker-1.1", true),
	}

	-- global table
	local _LG,_lib = self._acelib.locale,self._acelib.lib
	if not _LG.base then
		_LG.base	= setmetatable({ {}, }, _LG.proxy)
		_LG.zone	= _lib.LZ	and inst:SafeCall(_lib.LZ.GetUnstrictLookupTable, _lib.LZ)
		_LG.boss	= _lib.LB	and inst:SafeCall(_lib.LB.GetUnstrictLookupTable, _lib.LB)
		_LG.class	= _lib.LC	and inst:SafeCall(_lib.LC.GetUnstrictLookupTable, _lib.LC)
		_LG.inv		= _lib.LI	and inst:SafeCall(_lib.LI.GetUnstrictLookupTable, _lib.LI)
		_LG.ctype	= _lib.LT	and inst:SafeCall(_lib.LT.GetUnstrictLookupTable, _lib.LT)
		_LG.baseR	= setmetatable({ _LG.base[1], }, _LG.proxyr)
		_LG.zoneR	= _lib.LZ	and inst:SafeCall(_lib.LZ.GetReverseLookupTable, _lib.LZ)
		_LG.bossR	= _lib.LB	and inst:SafeCall(_lib.LB.GetReverseLookupTable, _lib.LB)
		_LG.classR	= _lib.LC	and inst:SafeCall(_lib.LC.GetReverseLookupTable, _lib.LC)
		_LG.invR	= _lib.LI	and inst:SafeCall(_lib.LI.GetReverseLookupTable, _lib.LI)
		_LG.ctypeR	= _lib.LT	and inst:SafeCall(_lib.LT.GetReverseLookupTable, _lib.LT)
	end

	-- instance table
	local _inst, _instG, _L = inst._acelib, self._acelib, inst._acelib.locale

	_inst.db	= _lib.db and _lib.db:New(_inst.nameDB, _inst.defaults) or inst:_GetDB(nil, _inst.nameDB, _inst.defaults, true)
	if _inst.lib.ac then tinsert(_inst.aaoembed, "AceConsole-3.0") end
	_L.capture	= inst._meta.lcapture and _inst.db.global.LCapture[inst._meta.locale] or { }
	_L.captureR	= inst._meta.lcapture and _inst.db.global.LCaptureR[inst._meta.locale] or { }
	_L.inst		= setmetatable({_lib.L and _lib.L:GetLocale(inst._instance.name, true) or {}}, _LG.proxy)
	_L.instR	= setmetatable({_L.inst[1]}, _LG.proxyr)
	_inst.LR = setmetatable({_L.captureR,_LG.zoneR,_LG.bossR,_LG.classR,_LG.invR,_LG.ctypeR,_L.instR,_LG.baseR, F=_LG.format,}, _LG.mt)
	_inst.L  = setmetatable({_L.capture,_LG.zone,_LG.boss,_LG.class,_LG.inv,_LG.ctype,_L.inst,_LG.base, S=_L.inst, F=_LG.format, R=_inst.LR,}, _LG.mt)

	self:LoadLocales( frame, inst, inst._meta.locale, _LG.base )


	-- --------- relies on player_login ----------
	
	_inst.instance	= _inst.lib.aao and _inst.lib.aao:NewAddon(_inst.name, unpack(_inst.aaoembed)) or { }
	_inst.menu  = { handler = _inst.instance, type = "group", args = {
			main	= {	type = "execute", order = 10, name = _inst.L["Main Window"], desc = _inst.L["Show Main Window"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce() end,			},
			options	= {	type = "execute", order = 10, name = _inst.L["Options"], desc = _inst.L["Show Options"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("options") end,	},
			help	= {	type = "execute", order = 20, name = _inst.L["Help"], desc = _inst.L["Show Help"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("help") end,		},
			hide	= {	type = 'execute', order = -13, name = _inst.L["Hide"], desc = _inst.L["Hide Icon"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("hide") end,		}, }, }
						
	if _inst.instance then													-- ace
		_inst.instance._karma				= inst
		_inst.instance._L					= _inst.L
		_inst.instance.db					= _inst.db
		_inst.instance.icon					= inst._meta.icon
		_inst.instance.title				= inst._meta.title
		_inst.instance.version				= inst._meta.version
		_inst.instance.ExecChatCommandAce	= LibKarmaAce.ExecChatCommandAce
		_inst.instance.ExecMenuCommandAce	= LibKarmaAce.ExecMenuCommandAce
		_inst.instance.OnMenuRequest		= _inst.menu
		_inst.instance.OnCommandAce			= LibKarmaAce.OnCommandAce
		_inst.instance.OnInitialize			= LibKarmaAce.OnInitialize
		_inst.instance.OnUpdateFuBarTooltip	= LibKarmaAce.OnUpdateFuBarTooltip
		_inst.instance.OnFuBarClick			= LibKarmaAce.OnFuBarClick
		_inst.instance.OnTooltipShow		= function(frame) inst._acelib.instance:OnUpdateFuBarTooltip(frame) end
		_inst.instance.OnClick				= function(frame,button) inst._acelib.instance:OnFuBarClick(button) end
	end
	if _inst.lib.ldb then
		_inst.instance.type					= "launcher"
		_G[_inst.nameLDB]					= _inst.lib.ldb:NewDataObject(_inst.instance.title, _inst.instance)
	end
	if _inst.lib.fu and _inst.lib.aao then									-- fubar via ace
		_inst.lib.aao:EmbedLibrary(_inst.instance, "LibFuBarPlugin-3.0", true)
		_inst.instance:SetFuBarOption("hasIcon", true)
		_inst.instance:SetFuBarOption("iconPath", _inst.instance.icon)
		_inst.instance:SetFuBarOption("hasNoColor", true)
		_inst.instance:SetFuBarOption("hideMenuTitle", true)
		_inst.instance:SetFuBarOption("independentProfile", true)
		_inst.instance:SetFuBarOption("clickableTooltip", true)
		_inst.instance:SetFuBarOption("cannotDetachTooltip", true)
		_inst.instance:SetFuBarOption("hideWithoutStandby", true)
		_inst.instance:SetFuBarOption("defaultPosition", "CENTER")
		_inst.instance:SetFuBarOption("configType", "Dewdrop-2.0")
	end	
	if not _inst.lib.fu and not SlashCmdList["TitanPanel"] then				-- no fubar no titan, make our own minimap icon
		_inst.instance.Hide			= LibKarmaAce.Hide
		_inst.instance.Show			= LibKarmaAce.Show
		_inst.minimap = LibKarmaUI:GenerateMinimapButton( frame, _inst.instance, _inst.db.profile.minimap )
		_inst.minimap:Reposition()
	end
	if not _inst.lib.aao and _inst.instance.OnInitialize then _inst.instance:OnInitialize()	end

	if CT_RegisterMod then													-- ct mod and related
		CT_RegisterMod(inst._meta.title, "Display window", 5, self._meta.icon,
			self._meta.desc, "switch", _inst.instance, function(self) self:ExecChatCommandAce() end )
	end

end


function LibKarmaAce:ExecMenuCommandAce( t )
	local _args = self._karma._acelib.menu.args
	t = ((type(t) == "string") and _args[t] or t) or _args.main
	if not t or type(t) ~= "table" then return end
	if t.type == "execute" then
		return self._karma:SafeCall(t.func, t.passValue)
	end
end

function LibKarmaAce:ExecChatCommandAce( cmd )
	local func = SlashCmdList[strupper(self._karma._instance.name)]
	if func then self._karma:SafeCall(func, cmd or "") end	
end

function LibKarmaAce:OnCommandAce( msg, cmd, args )
	local _inst = self._karma._acelib
	if cmd == "hide" then
		local isShown = ((_inst.lib.fu and _inst.lib.aao) and self:GetFrame():IsShown()) or (_inst.minimap and _inst.minimap:IsVisible())
		if not isShown then	self:Show()	else self:Hide() end
		return true
	elseif cmd == "help" then
		self._karma:Print("/" .. self._karma._meta.short .. " hide - Hides the icon.")
	end
end

function LibKarmaAce:Hide()
	local _inst = self._karma._acelib
	_inst.minimap:Hide()
end

function LibKarmaAce:Show()
	local _inst = self._karma._acelib
	_inst.minimap:Show()
end

function LibKarmaAce:OnUpdateFuBarTooltip(f)
	f = f or GameTooltip
	f:AddLine(self._L[self.title]);
	f:AddLine(self._L["ADDON_TOOLTIP"], 0.2, 1, 0.2, 1);
end

function LibKarmaAce:OnFuBarClick(button)
	self:ExecMenuCommandAce( IsShiftKeyDown() and "options" )
end

function LibKarmaAce:OnInitialize( )
	local _inst = self._karma._acelib
	if _inst.menu and _inst.lib.fu and _inst.lib.aao then
		self._karma:ArgsToTable(_inst.menu.args, _inst.lib.fu:GetEmbedRockConfigOptions(_inst.instance))
		for i, v in pairs (_inst.menu.args) do
			if v.type == "boolean" then v.type = "toggle" end
			if v.type == "choice" then v.type = "text" end
			if v.choices then v.validate = v.choices end
			if i == "hide" then v.name = "Hide" end
		end
	end
end



